/* Created by Anjuta version 1.0.0 */
/*	This file will not be overwritten */

/* hlavni program - b-tree */

#include "btree.h"
#include <stdio.h>
#include <string.h>

int N;
 // rad stromu
P_CBTREE p_root;
 

int main(int argc, char *argv[])
{	
	int num;
	int dump_struct = 0;
	p_root = NULL;
	
    char str_num[16];
	
	// je parametr -s ? pak budeme vypisovat ozavorkovanou strukturu,
	// jinak vypiseme serazena cisla
	if ((argc != 1) && (strcmp(argv[1],"-s") == 0)) 
	{
		dump_struct = 1;
	}

	fgets(str_num, 15, stdin); // na prvnim radku je rad b-stromu
	sscanf(str_num, "%d", &num);
	N = num;

	p_root = new CBTree(NULL, NULL); // vytvorime strom
	fgets(str_num, 15, stdin); // mezi radem a cisly je jedna volna radka
	
	while (fgets(str_num, 15, stdin)) // nacteni a vkladani dat do stromu
	{
		sscanf(str_num, "%d", &num);
		if (num<0) {  // cislo je zaporne -> vyjimame
			if (p_root != NULL )
				p_root->delete_num(-num);			
		} else { // cislo je kladne -> vlozeni
			p_root->insert_num(num);
		}
	}
					
	if (p_root != NULL) { // pokud mame strom, tak ho vypiseme
		if (dump_struct == 1) { // pokud jsme zadali parametr -s
			p_root->dump_structure(0, stdout);  // vypisujeme zavorkovanou strukturu
		} else {
			p_root->dump_numbers(0, stdout); // jinak jen serazena cisla
		}
		delete p_root; // zrusime
	}
	
	return 0;
}
